# #C240609A. 商品打包

## 题目描述

有 $n$ 个商品，第 $i$ 个商品的体积为 $a_i$。你有若干个容量为 $L$ 的背包。

在第 $i$ 天，你希望将所有编号为 $i, i+1, \cdots, n-1, n$ 的物品装入背包带走。你将物品装入背包的策略为，依次对每个物品 $k = i, i+1, \cdots, n$：

- 如果当前背包剩余容量大于等于 $a_k$，则将该物品装入背包。
- 否则，则将该背包带走，并拿出一个全新的背包，回到第一步。

你想要知道，对每个 $i = 1, 2, \cdots, n$，所需背包的数量 $f_i$ 是多少。

## 输入格式

输入的第一行包含两个整数 $n$ 和 $L$。

接下来一行，包含 $n$ 个整数 $a_1, a_2, \cdots, a_n$。

## 输出格式

输出一行 $n$ 个整数 $f_1, f_2, \cdots, f_n$，表示答案。

## 样例

### 输入数据 1

```
6 3
1 2 2 2 1 2
```

### 输出数据 1

```
4 4 3 2 1 1
```

### 样例2

见选手目录下 $pack/pack2.in$ 与 $pack/pack2.ans$。

## 数据规模与约定

对于所有数据，$1 \leq n \leq 2 \times 10^5$，$1 \leq L \leq 10^9$，$1 \leq a_i \leq L$。

| 子任务编号 | 特殊性质                         | 分值 |
| :--------- | :------------------------------- | :--- |
| 1          | $n \leq 1000$                    | 25   |
| 2          | 所有的 $a_i$ 均相等              | 20   |
| 3          | $a_i$ 在 $[1, L]$ 内均匀随机生成 | 30   |
| 4          | 没有额外的限制                   | 25   |

# #C240609B. 集合

## 题目描述

你的手中有一个正整数 $n$，但是你觉得只有这一个整数实在太过无聊，于是你找到了一个大小为 $m$ 的**可重集合** $B$。

每次你可以在集合 $B$ 中选出一个元素 $x \in B$，将 $n$ 变为 $\lfloor \frac{n}{x} \rfloor$。

问通过上述操作，能将 $n$ 能变成多少种不同的数。

## 输入格式

输入的第一行包含两个整数 $n$ 和 $m$。

接下来一行，包含 $m$ 个整数 $x_1, x_2, \cdots, x_m$，描述 $B$ 中的元素。**注意 $B$ 中可能包含相同的元素。**

## 输出格式

输出一行一个整数，表示答案。

## 样例

### 输入数据 1

```
7 2
2 3
```

**【样例1解释】**

$n$ 可能的取值分别为：

- $n=7$：初始状态
- $n=3$：在 $n=7$ 时令 $x=2$
- $n=2$：在 $n=7$ 时令 $x=3$
- $n=1$：在 $n=2$ 时令 $x=2$
- $n=0$：在 $n=2$ 时令 $x=3$

### 输出数据 1

```
5
```

### 输入数据 2

```
12 4
1 2 4 5
```

### 样例2解释

详细解释略，直接给出结果。

### 输出数据 2

```
6
```

### 样例3

见选手目录下 $set/set3.in$ 与 $set/set3.ans$。

## 数据规模与约定

对于所有数据，$1 \leq n \leq 10^{15}$，$1 \leq x \leq 10^{15}$，$1 \leq m \leq 10$。

| 子任务编号 | 特殊性质         | 分值 |
| :--------- | :--------------- | :--- |
| 1          | $n, x \leq 100$  | 15   |
| 2          | $n, x \leq 10^6$ | 10   |
| 3          | $n, x \leq 10^9$ | 10   |
| 4          | $m = 1$          | 10   |
| 5          | $m = 2$          | 15   |
| 6          | $m \leq 6$       | 25   |
| 7          | 没有额外的限制   | 15   |



# C240609C. 最小生成树

## 题目描述

在图论中，无向图 $G$ 的生成树，是具有 $G$ 的全部顶点，但**边数最少**的**连通子图**。

而 $G$ 的最小生成树，即为 $G$ 中所有的生成树中，所有边的边权和最小的一棵生成树。

给定一个数组 $x_1, x_2, \cdots, x_n$。构造一张 $n$ 个点的完全图。对于任意 $1 \leq i < j \leq n$，图中有一条边权为 $x_j - x_i$ 的无向边。

你想要求出这张无向图的最小生成树的边权之和。

## 输入格式

输入的第一行包含一个整数 $n$。

接下来一行，包含 $n$ 个整数 $x_1, x_2, \cdots, x_n$。

## 输出格式

输出一行一个整数，表示答案。

## 样例

### 输入数据 1

```
8
-3 5 -1 2 0 4 6 3
```

### 输出数据 1

```
-18
```

### 输入数据 2

```
3
1 2 3
```

### 输出数据 2

```
2
```

### 样例3

见选手目录下 $mst/mst3.in$ 与 $mst/mst3.ans$。

## 数据规模与约定

对于所有数据，$1 \leq n \leq 3 \times 10^5$，$-300\,000 \leq x_i \leq 300\,000$。

| 子任务编号 | 特殊性质             | 分值 |
| :--------- | :------------------- | :--- |
| 1          | $n \leq 10$          | 5    |
| 2          | $n \leq 1\,000$      | 20   |
| 3          | $n \leq 10\,000$     | 15   |
| 4          | $x_i \in \{0, 1\}$   | 10   |
| 5          | $0 \leq x_i \leq 10$ | 15   |
| 6          | $n \leq 10^5$        | 15   |
| 7          | 没有额外的限制       | 20   |

# #C240609D. 子序列

## 题目描述

给定一个长为 $n$ 的仅有小写英文字母构成的字符串 $S = S_1S_2\cdots S_n$。我们定义一个字符串是好的，当且仅当它可以用**两个不同的字母** `x` 和 `y` 表示成 `xyxyxyx...` 的形式。例如，字符串 `abab`、`tot`、`z` 是好的，但字符串 `abc`、`aa` 不是好的。

现在有 $q$ 组询问，每次给定 $1 \leq l \leq r \leq n$，你想要求出，对于串 $S$ 的子串 $S[l\cdots r]$，它最长的一个好的子序列的长度是多少，以及它可以被哪两个不同字符 `x` 和 `y` 来表示。如果有多个最长的串，则输出字典序最小的一个串的 `x` 与 `y`。

## 输入格式

输入的第一行包含一个字符串 $S$。

接下来一行，包含一个整数 $m$。

接下来 $m$ 行，每行两个整数 $l, r$。

## 输出格式

对于每组询问，输出一行一个整数 $L$ 与两个字符 `xy`，分别表示最长好的子序列的长度，以及他们可以被哪两个字符表示。如果有多种符合条件的子序列，选择 `xy` 的字典序最小的。

## 样例

### 输入数据 1

```
abbbcadcac
7
4 10
6 10
4 10
1 9
3 8
5 9
1 7
```

### 输出数据 1

```
5 ca
4 ac
5 ca
5 ac
3 ca
4 ca
3 ab
```

### 样例2

见选手目录下 $seq/seq2.in$ 与 $seq/seq2.ans$。

## 数据规模与约定

对于所有数据，$1 \leq n \leq 1.5 \times 10^6$，$1 \leq m \leq 10^5$，$1 \leq l \leq r \leq n$。

| 子任务编号 | 特殊性质                                                     | 分值 |
| :--------- | :----------------------------------------------------------- | :--- |
| 1          | $n, m \leq 10$                                               | 5    |
| 2          | $n, m \leq 1000$                                             | 15   |
| 3          | $n, m \leq 50000$                                            | 20   |
| 4          | $n \leq 10^5$，$S$ 只由 2 种字符 `a` 和 `b` 组成             | 10   |
| 5          | $n \leq 2 \times 10^5$，$S$ 只由 6 种字符 `abcdef` 组成      | 20   |
| 6          | $n \leq 5 \times 10^5$，$S$ 只由 14 种字符 `abcdefghijklmn` 组成 | 20   |
| 7          | 没有额外的限制                                               | 10   |